# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.22.9-61.fc6}
# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name sysprof
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%ifarch i686
%define pae PAE
%endif
%ifarch ppc
%define smp smp
%endif
%ifarch i686 x86_64 ia64
%define xen xen
%endif
%ifarch i686 x86_64 ppc64 ppc64iseries
%define kdump kdump
%endif
%{!?kvariants: %define kvariants "" %{?pae} %{?smp} }
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 


Name:           %{kmod_name}-kmod
Version:        1.0.8
Release:        1.%(echo %{kverrel} | tr - _)
Summary:        Sysprof kernel module

Group:          System Environment/Kernel
License:        GPLv2+
URL:            http://www.daimi.au.dk/~sandmann/sysprof/
Source0:        http://www.daimi.au.dk/~sandmann/sysprof/sysprof-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         %{kmod_name}-avoid_depmod.patch

ExclusiveArch:  i586 i686 x86_64


%description
Sysprof is a sampling CPU profiler for Linux that uses a
kernel module to profile the entire system, not just a 
single application. Sysprof handles shared libraries and 
applications do not need to be recompiled. In fact they 
don't even have to be restarted. 


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5

%setup -q -c -T -a 0
pushd %{kmod_name}-%{version}*
%patch0 -p1 -b .patch0
# configure script breaks in mock builds (missing BRs), so we create here 
# a config.h with the needed symbol
echo '#define PACKAGE_VERSION "%{version}"' > config.h
popd

for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-%{version} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant/module
    make KDIR="${ksrc}" 
    cd ../..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    cd _kmod_build_$kvariant/module
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    export INSTALL_MOD_DIR=extra/%{kmod_name}
    export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
    make KDIR=${ksrc} install 
    cd ../..
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Tue Aug 21 2007 Gianluca Sforna <giallu gmail com>
- Update License field

* Tue Jan  2 2007 Gianluca Sforna <giallu gmail com>
- rebuild for kernel 2.6.18-1.2869

* Sat Dec 23 2006 Gianluca Sforna <giallu gmail com> 1.0.8-1
- version update to 1.0.8
- rebuild for kernel 2.6.18-1.2868

* Tue Nov 21 2006 Gianluca Sforna <giallu gmail com> 1.0.7-1
- version update to 1.0.7

* Mon Nov 13 2006 Gianluca Sforna <giallu gmail com>
- rebuild for kernel 2.6.18-1.2849

* Thu Nov  2 2006 Gianluca Sforna <giallu gmail com> 1.0.5-1
- version update
- drop upstreamed patch

* Tue Oct 17 2006 Gianluca Sforna <giallu gmail com>
- rebuild for kernel 2.6.18-1.2798

* Sun Oct 8 2006 Gianluca Sforna <giallu gmail com> 1.0.3-5
- rebuild for kernel 2.6.18-1.2747
- add patch for linux/config.h include

* Thu Oct 5 2006 Gianluca Sforna <giallu gmail com> 1.0.3-3
- rebuild

* Thu Oct 5 2006 Gianluca Sforna <giallu gmail com> 1.0.3-2
- remove (not supported) ppc arch

* Thu Jun 22 2006 Gianluca Sforna <giallu gmail com> 1.0.3-1
- version update
- fixed rpmlint warning about summary 

* Sat May 13 2006 Gianluca Sforna <giallu gmail com> 1.0.2-2
- removed some unnecessary diffs from the template spec

* Sat May 13 2006 Gianluca Sforna <giallu gmail com> 1.0.2-1
- Initial Version
